#include "mbed.h"
#include "MLX90620.h" 

char* EEbuf = new char[256];     //buffer for contents of EEPROM
char* RamCmmd = new char[8];     //holds / sends MLX90620 RAM commands
char* RamBuf = new char[128];    //0x3f words, values are 'unsigned short'
 
Serial pc(USBTX, USBRX);
I2C i2c(PTE0,PTE1);
MLX90620 mlx(&i2c);

float Ta = 0.0;
float TempPxl = 0.0;

int main() {
   pc.baud(115200);
   mlx.GetEEPROM();
   mlx.SetOscTrimReg();
   mlx.SetConfigReg();
   mlx.StartMeasurement(); 
   wait(0.5);
   mlx.CalcTa_To();
   Ta = mlx.GetDieTemp();
   pc.printf("\nTa = %f\n\n", Ta);
   while(1) {
       int config = mlx.GetConfigReg();
       int chk = config & 0x0300;
       if(chk == 0) {
           pc.printf("\nIR Array Capture\n");
           mlx.GetMLXRam();
           mlx.StartMeasurement();
           for(int i = 0; i < 64; i++) {
               TempPxl = mlx.CalcPixel(i);
               pc.printf("Pix %2d   Temp %.3f\n", i, TempPxl);
           }
       } else {
           wait_ms(100);
           pc.printf("config: 0x%04x\n", config);
       }
   wait(1);
  }
}